## Auth service

Auth service — Support for the Auth service.

## Functions

MbimMessage * | mbim_message_auth_aka_query_new ()
gboolean | mbim_message_auth_aka_response_parse ()
MbimMessage * | mbim_message_auth_akap_query_new ()
gboolean | mbim_message_auth_akap_response_parse ()
MbimMessage * | mbim_message_auth_sim_query_new ()
gboolean | mbim_message_auth_sim_response_parse ()

## Description

This section implements support for requests, responses and notifications in the Auth service.

## Functions

### mbim_message_auth_aka_query_new ()

    MbimMessage *
    mbim_message_auth_aka_query_new (const guint8 *rand,
                                     const guint8 *autn,
                                     GError **error);

Create a new request for the 'Aka' query command in the 'Auth' service.

#### Parameters

rand | the 'Rand' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
autn | the 'Autn' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.4

### mbim_message_auth_aka_response_parse ()

    gboolean
    mbim_message_auth_aka_response_parse (const MbimMessage *message,
                                          const guint8 **out_res,
                                          guint32 *out_res_len,
                                          const guint8 **out_integrating_key,
                                          const guint8 **out_ciphering_key,
                                          const guint8 **out_auts,
                                          GError **error);

Parses and returns parameters of the 'Aka' response command in the 'Auth' service.

#### Parameters

message | the MbimMessage. |
out_res | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_res_len | return location for a guint32, or `NULL` if the 'ResLen' field is not needed. | [out][optional][transfer none]
out_integrating_key | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_ciphering_key | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_auts | return location for an array of 14 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=14]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.4

### mbim_message_auth_akap_query_new ()

    MbimMessage *
    mbim_message_auth_akap_query_new (const guint8 *rand,
                                      const guint8 *autn,
                                      const gchar *network_name,
                                      GError **error);

Create a new request for the 'Akap' query command in the 'Auth' service.

#### Parameters

rand | the 'Rand' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
autn | the 'Autn' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
network_name | the 'NetworkName' field, given as a string. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.4

### mbim_message_auth_akap_response_parse ()

    gboolean
    mbim_message_auth_akap_response_parse (const MbimMessage *message,
                                           const guint8 **out_res,
                                           guint32 *out_res_len,
                                           const guint8 **out_integrating_key,
                                           const guint8 **out_ciphering_key,
                                           const guint8 **out_auts,
                                           GError **error);

Parses and returns parameters of the 'Akap' response command in the 'Auth' service.

#### Parameters

message | the MbimMessage. |
out_res | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_res_len | return location for a guint32, or `NULL` if the 'ResLen' field is not needed. | [out][optional][transfer none]
out_integrating_key | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_ciphering_key | return location for an array of 16 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=16]
out_auts | return location for an array of 14 guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array fixed-size=14]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.4

### mbim_message_auth_sim_query_new ()

    MbimMessage *
    mbim_message_auth_sim_query_new (const guint8 *rand1,
                                     const guint8 *rand2,
                                     const guint8 *rand3,
                                     guint32 n,
                                     GError **error);

Create a new request for the 'Sim' query command in the 'Auth' service.

#### Parameters

rand1 | the 'Rand1' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
rand2 | the 'Rand2' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
rand3 | the 'Rand3' field, given as an array of 16 guint8 values. | [in][element-type guint8][array fixed-size=16]
n | the 'N' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.4

### mbim_message_auth_sim_response_parse ()

    gboolean
    mbim_message_auth_sim_response_parse (const MbimMessage *message,
                                          guint32 *out_sres1,
                                          guint64 *out_kc1,
                                          guint32 *out_sres2,
                                          guint64 *out_kc2,
                                          guint32 *out_sres3,
                                          guint64 *out_kc3,
                                          guint32 *out_n,
                                          GError **error);

Parses and returns parameters of the 'Sim' response command in the 'Auth' service.

#### Parameters

message | the MbimMessage. |
out_sres1 | return location for a guint32, or `NULL` if the 'Sres1' field is not needed. | [out][optional][transfer none]
out_kc1 | return location for a guint64, or `NULL` if the 'Kc1' field is not needed. | [out][optional][transfer none]
out_sres2 | return location for a guint32, or `NULL` if the 'Sres2' field is not needed. | [out][optional][transfer none]
out_kc2 | return location for a guint64, or `NULL` if the 'Kc2' field is not needed. | [out][optional][transfer none]
out_sres3 | return location for a guint32, or `NULL` if the 'Sres3' field is not needed. | [out][optional][transfer none]
out_kc3 | return location for a guint64, or `NULL` if the 'Kc3' field is not needed. | [out][optional][transfer none]
out_n | return location for a guint32, or `NULL` if the 'N' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.4